#include <windows.h>
#include  <zmouse.h>
#include  <stdio.h>
#ifndef  _h_msrev_
#define  _h_msrev_
#include  "msrev.h"
#endif





HHOOK     hMod ;
HINSTANCE hInst ;
RevState  myState ;

int  WINAPI DllMain( HINSTANCE h,  DWORD fdwReason,  PVOID pvReserved){
	hInst = h ;
	hMod = NULL ;
	myState = NONE_REV ;
    return  TRUE ;
}



LRESULT CALLBACK  MouseProc1(int nCode,  WPARAM wParam,  LPARAM lParam){
	MSG* msg = (MSG*)lParam ;
	short hword = (short)HIWORD(msg->wParam) ;
	short lword = (short)LOWORD(msg->wParam) ;
	if( nCode >= 0 && msg->message == WM_MOUSEWHEEL){
		hword = -hword ;
		msg->wParam = ((DWORD)hword)<<16 | (DWORD)lword ;
	}
	return  CallNextHookEx( hMod, nCode, wParam, lParam) ;
}

LRESULT CALLBACK  MouseProc2(int nCode,  WPARAM wParam,  LPARAM lParam){
	MSG* msg = (MSG*)lParam ;
	short hword = (short)HIWORD(msg->wParam) ;
	short lword = (short)LOWORD(msg->wParam) ;
	if( nCode >= 0 && msg->message == WM_MOUSEWHEEL && LOWORD(msg->wParam) == MK_SHIFT){
		hword = -hword ;
		msg->wParam = ((DWORD)hword)<<16 | (DWORD)lword ;
	}
	return  CallNextHookEx( hMod, nCode, wParam, lParam) ;
}

LRESULT CALLBACK  MouseProc3(int nCode,  WPARAM wParam,  LPARAM lParam){
	MSG* msg = (MSG*)lParam ;
	short hword = (short)HIWORD(msg->wParam) ;
	short lword = (short)LOWORD(msg->wParam) ;
	if( nCode >= 0 && msg->message == WM_MOUSEWHEEL && LOWORD(msg->wParam) == MK_CONTROL){
		hword = -hword ;
		msg->wParam = ((DWORD)hword)<<16 | (DWORD)lword ;
	}
	return  CallNextHookEx( hMod, nCode, wParam, lParam) ;
}


EXPORT BOOL  Setmhook( RevState sendState){
	if( hMod != NULL){
		if( !Unsetmhook()){
			return  FALSE ;
		}
	}

	switch( sendState){
		case  ALL_REV :
			hMod = SetWindowsHookEx( WH_GETMESSAGE, (HOOKPROC)MouseProc1, hInst,  0) ;
			myState = ALL_REV ;
			break ;

		case  SHIFT_REV :
			hMod = SetWindowsHookEx( WH_GETMESSAGE, (HOOKPROC)MouseProc2, hInst,  0) ;
			myState = SHIFT_REV ;
			break ;

		case  CTRL_REV :
			hMod = SetWindowsHookEx( WH_GETMESSAGE, (HOOKPROC)MouseProc3, hInst,  0) ;
			myState = CTRL_REV ;
			break ;

		default :
			MessageBox( NULL, TEXT("sȃtbN"), TEXT("MsRevDLL"), MB_ICONSTOP | MB_OK) ;
			return  FALSE ;
			break ;
	}
	if( hMod == NULL){
		myState = NONE_REV ;
		return  FALSE ;
	}
	return  TRUE ;
}

EXPORT BOOL  Unsetmhook () {
	if( hMod == NULL){
		return  TRUE ;
	}
	if( UnhookWindowsHookEx( hMod)){
		hMod = NULL ;
		myState = NONE_REV ;
		return  TRUE ;
	}
	return  FALSE ;
}

EXPORT RevState  GetMsRevState () {
	return  myState ;
}
